<?php
  // Create menu
  $title = __('Board', 'forums');
  frm_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  if(frm_is_demo()) {
    message_error( __('This is demo site, you cannot manage boards.', 'forums') );
  }


  if(Params::getParam('plugin_action') == 'done' && !frm_is_demo()) {
    $boards = ModelFRM::newInstance()->getBoards('', -1);
    $board_ids = array_column($boards, 'pk_i_id');
    $new_ids = range(-1, -Params::getParam('max_new_id'));

    $all_ids = array_filter(array_merge($board_ids, $new_ids));

    $post = Params::getParamsAsArray();

    if(count($all_ids) > 0) {
      foreach($all_ids as $i) {
        if(isset($post['board_id_' . $i])) {

          $data = array(
            'fk_i_category_id' => $post['board_cat_' . $i],
            'fk_i_parent_id' => $post['board_parent_' . $i],
            's_premium_groups_ids' => @$post['board_prem_' . $i],
            's_moderators_ids' => @$post['board_mod_' . $i]
          );

          if($post['board_id_' . $i] > 0) {
            $data['pk_i_id'] = $post['board_id_' . $i];
          }

          $data_locale = array(
            'fk_c_locale_code' => (Params::getParam('frmLocale') <> '' ? Params::getParam('frmLocale') : frm_get_locale()),
            's_name' => $post['board_name_' . $i],
            's_description' => $post['board_desc_' . $i]
          );
 
          ModelFRM::newInstance()->updateBoard($i, $data, $data_locale);
        }
      }
    }
 
    message_ok( __('Boards were successfully updated', 'forums') );
  }


  // REMOVE BOARD
  if(Params::getParam('what') == 'remove' && Params::getParam('id') > 0 && !frm_is_demo()) {
    ModelFRM::newInstance()->removeBoard(Params::getParam('id'));
    message_ok( __('Board removed successfully', 'forums') );
  }
 


  $boards = ModelFRM::newInstance()->getBoards('', -1);

  $boards_parent = $boards;
  $categories = ModelFRM::newInstance()->getCategories();
  $moderators = ModelFRM::newInstance()->getModeratorUsers();
?>



<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-list"></i> <?php _e('Boards', 'forums'); ?>
      <?php echo frm_locale_box('board.php'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>board.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <input type="hidden" name="fk_c_locale_code" value="<?php echo frm_get_locale(); ?>" />
        <input type="hidden" name="frmLocale" value="<?php echo frm_get_locale(); ?>" />
        <input type="hidden" name="max_new_id" value="0" />


        <div class="mb-table mb-table-board">
          <div class="mb-table-head">
            <div class="mb-col-1"><?php _e('ID', 'forums'); ?></div>
            <div class="mb-col-3 mb-input-box mb-align-left"><?php _e('Board Name', 'forums'); ?></div>
            <div class="mb-col-6 mb-input-box mb-align-left"><?php _e('Description', 'forums'); ?></div>
            <div class="mb-col-3 mb-input-box mb-align-left"><?php _e('Category', 'forums'); ?></div>
            <div class="mb-col-3 mb-input-box mb-align-left"><?php _e('Parent Board', 'forums'); ?></div>
            <div class="mb-col-3 mb-input-box mb-align-left"><?php _e('Moderators', 'forums'); ?></div>
            <div class="mb-col-3 mb-input-box mb-align-left"><?php _e('Premium Groups', 'forums'); ?></div>
            <div class="mb-col-2">&nbsp;</div>
          </div>

          <?php if(count($boards) > 0) { ?>
            <?php foreach($boards as $b) { ?>
              <?php
                $board_mod = explode(',', isset($b['s_moderators_ids']) ? $b['s_moderators_ids'] : '');
                $board_prem = explode(',', isset($b['s_premium_groups_ids']) ? $b['s_premium_groups_ids'] : '');
              ?>

              <div class="mb-table-row">
                <div class="mb-col-1 mb-col-id mb-input-box"><input type="text" name="board_id_<?php echo $b['pk_i_id']; ?>" value="<?php echo $b['pk_i_id']; ?>" readonly="readonly"></div>
                <div class="mb-col-3 mb-col-name mb-input-box mb-align-left"><input type="text" name="board_name_<?php echo $b['pk_i_id']; ?>" value="<?php echo @$b['locales'][frm_get_locale()]['s_name']; ?>" placeholder="<?php echo osc_esc_html(__('New board', 'forums')); ?>"></div>
                <div class="mb-col-6 mb-col-desc mb-input-box mb-align-left"><input type="text" name="board_desc_<?php echo $b['pk_i_id']; ?>" value="<?php echo @$b['locales'][frm_get_locale()]['s_description']; ?>"></div>

                <div class="mb-col-3 mb-col-cat mb-input-box mb-align-left">
                  <select name="board_cat_<?php echo $b['pk_i_id']; ?>">
                    <?php if(count($categories) > 0) { ?>
                      <?php foreach($categories as $c) { ?>
                        <option value="<?php echo $c['pk_i_id']; ?>" <?php if($c['pk_i_id'] == $b['fk_i_category_id']) { ?>selected="selected"<?php } ?>><?php echo frm_name($c); ?></option>
                      <?php } ?>
                    <?php } ?>
                  </select>
                </div>

                <div class="mb-col-3 mb-col-parent mb-input-box mb-align-left">
                  <select name="board_parent_<?php echo $b['pk_i_id']; ?>">
                    <option value="" <?php if($b['fk_i_parent_id'] == '') { ?>selected="selected"<?php } ?>><?php _e('Root', 'forums'); ?></option>

                    <?php foreach($boards_parent as $bp) { ?>
                      <?php if($bp['pk_i_id'] <> $b['pk_i_id']) { ?>
                        <option value="<?php echo $bp['pk_i_id']; ?>" <?php if($bp['pk_i_id'] == $b['fk_i_parent_id']) { ?>selected="selected"<?php } ?>><?php echo frm_name($bp); ?></option>
                      <?php } ?>
                    <?php } ?>
                  </select>
                </div>

                <div class="mb-col-3 mb-col-mod mb-input-box mb-align-left mb-row-select-multiple">
                  <input type="hidden" name="board_mod_<?php echo $b['pk_i_id']; ?>" value="<?php echo $b['s_moderators_ids']; ?>" />
                  <select name="board_mod_<?php echo $b['pk_i_id']; ?>_multiple" multiple class="mb-multiple">
                    <?php if(count($moderators) > 0) { ?>
                      <?php foreach($moderators as $m) { ?>
                        <option value="<?php echo $m['pk_i_id']; ?>" <?php if(in_array($m['pk_i_id'], $board_mod)) { ?>selected="selected"<?php } ?>><?php echo frm_user_name($m); ?></option>
                      <?php } ?>
                    <?php } else { ?>
                      <option value=""><?php _e('There are no moderators', 'forums'); ?></option>
                    <?php } ?>
                  </select>
                </div>

                <div class="mb-col-3 mb-col-prem mb-input-box mb-align-left mb-row-select-multiple">
                  <input type="hidden" name="board_prem_<?php echo $b['pk_i_id']; ?>" value="<?php echo $b['s_premium_groups_ids']; ?>" />
                  <select name="board_prem_<?php echo $b['pk_i_id']; ?>_multiple" multiple class="mb-multiple">
                    <?php if(frm_premium_groups()) { ?>
                      <?php foreach(frm_premium_groups() as $g) { ?>
                        <option value="<?php echo $g['pk_i_id']; ?>" <?php if(in_array($g['pk_i_id'], $board_prem)) { ?>selected="selected"<?php } ?>><?php echo $g['s_name']; ?></option>
                      <?php } ?>
                    <?php } else { ?>
                      <option value=""><?php _e('Install Osclass Pay and enable user groups', 'forums'); ?></option>
                    <?php } ?>
                  </select>
                </div>

                <div class="mb-col-2 mb-col-del">
                  <?php if(!frm_is_demo()) { ?>
                    <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=forums/admin/board.php&what=remove&id=<?php echo $b['pk_i_id']; ?>" onclick="return confirm('Are you sure you want to delete this board? This will remove all topics and post in this board. Action cannot be undone.')" class="mb-remove mb-btn mb-button-red"><i class="fa fa-trash-o"></i> <span><?php echo __('Remove', 'forums'); ?></span></a>
                  <?php } else { ?>
                    <a href="#" onclick="return false;" class="mb-remove mb-btn mb-button-red frm-has-tooltip-right mb-disabled" style="opacity:0.5;cursor:not-allowed;" disabled title="<?php echo osc_esc_html(__('This is demo site', 'forums')); ?>"><i class="fa fa-trash-o"></i> <span><?php echo __('Remove', 'forums'); ?></span></a>
                  <?php } ?>
                </div>
              </div>
            <?php } ?>
          <?php } else { ?>
            <div class="mb-table-row mb-row-empty">
              <i class="fa fa-warning"></i><span><?php _e('No boards has been created yet', 'forums'); ?></span>
            </div>
          <?php } ?>
        </div>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-board-placeholder" style="display:none;">
          <div class="mb-table-row">
            <div class="mb-col-1 mb-col-id mb-input-box"><input type="text" name="board_id_" value="" readonly="readonly" placeholder="xx"></div>
            <div class="mb-col-3 mb-col-name mb-input-box mb-align-left"><input type="text" name="board_name_" value="" placeholder="<?php echo osc_esc_html(__('New board', 'forums')); ?>"></div>
            <div class="mb-col-6 mb-col-desc mb-input-box mb-align-left"><input type="text" name="board_desc_" value=""></div>

            <div class="mb-col-3 mb-col-cat mb-input-box mb-align-left">
              <select name="board_cat_">
                <?php if(count($categories) > 0) { ?>
                  <?php foreach($categories as $c) { ?>
                    <option value="<?php echo $c['pk_i_id']; ?>"><?php echo frm_name($c); ?></option>
                  <?php } ?>
                <?php } ?>
              </select>
            </div>

            <div class="mb-col-3 mb-col-parent mb-input-box mb-align-left">
              <select name="board_parent_">
                <option value="" selected="selected"><?php _e('Root', 'forums'); ?></option>

                <?php foreach($boards_parent as $bp) { ?>
                  <option value="<?php echo $bp['pk_i_id']; ?>"><?php echo frm_name($bp); ?></option>
                <?php } ?>
              </select>
            </div>

            <div class="mb-col-3 mb-col-mod mb-input-box">&nbsp;</div>
            <div class="mb-col-3 mb-col-prem mb-input-box">&nbsp;</div>

            <div class="mb-col-2 mb-col-del"><a href="#" class="mb-remove mb-btn mb-button-red new-board-remove"><i class="fa fa-trash-o"></i> <span><?php echo __('Remove', 'forums'); ?></span></a></div>
          </div>
        </div>

        <a class="mb-button-green mb-new-board" href="#"><i class="fa fa-plus-circle"></i> <?php _e('Add a new board', 'forums'); ?></a>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!frm_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'forums');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>
</div>

<script>
  var brdToCat = new Array();

  <?php 
    $js_array = array();

    if(count($boards) > 0) {
      foreach($boards as $b) { 
        echo 'brdToCat[' . $b['pk_i_id'] . '] = ' . $b['fk_i_category_id'] . ';';
      } 
    }
  ?>
</script>


<?php echo frm_footer(); ?>