<?php
  // Create menu
  $title = __('Category', 'forums');
  frm_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value

  if(frm_is_demo()) {
    message_error( __('This is demo site, you cannot manage categories.', 'forums') );
  }


  if(Params::getParam('plugin_action') == 'done' && !frm_is_demo()) {
    $post = Params::getParamsAsArray();
    
    foreach($post as $n => $v) {
      $name = explode('_', $n);

      if(@$name[0] == 'cat' && @$name[1] == 'name') {
        $id = $name[2];

        ModelFRM::newInstance()->updateCategory($id, $v, Params::getParam('frmLocale'));
      }
    }
 
    message_ok( __('Categories were successfully updated', 'forums') );
  }


  // REMOVE CATEGORY
  if(Params::getParam('what') == 'remove' && Params::getParam('id') > 0 && !frm_is_demo()) {
    ModelFRM::newInstance()->removeCategory(Params::getParam('id'));
    message_ok( __('Category removed successfully', 'forums') );
  }
 


  $categories = ModelFRM::newInstance()->getCategories();

?>



<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-list"></i> <?php _e('Categories', 'forums'); ?>
      <?php echo frm_locale_box('category.php'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>category.php" />
        <input type="hidden" name="plugin_action" value="done" />
        <input type="hidden" name="fk_c_locale_code" value="<?php echo frm_get_locale(); ?>" />
        <input type="hidden" name="frmLocale" value="<?php echo frm_get_locale(); ?>" />


        <div class="mb-table mb-table-category">
          <div class="mb-table-head">
            <div class="mb-col-1"><?php _e('ID', 'forums'); ?></div>
            <div class="mb-col-20 mb-input-box mb-align-left"><?php _e('Category Name', 'forums'); ?></div>
            <div class="mb-col-3">&nbsp;</div>
          </div>

          <?php if(count($categories) > 0) { ?>
            <?php foreach($categories as $c) { ?>
              <div class="mb-table-row">
                <div class="mb-col-1 mb-col-id mb-input-box"><input type="text" name="cat_id_<?php echo $c['pk_i_id']; ?>" value="<?php echo $c['pk_i_id']; ?>" readonly="readonly"></div>
                <div class="mb-col-20 mb-col-name mb-input-box mb-align-left"><input type="text" name="cat_name_<?php echo $c['pk_i_id']; ?>" value="<?php echo @$c['locales'][frm_get_locale()]['s_name']; ?>" placeholder="<?php echo osc_esc_html(__('New category', 'forums')); ?>"></div>
                <div class="mb-col-3 mb-col-del">
                  <?php if(!frm_is_demo()) { ?>
                    <a href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=forums/admin/category.php&what=remove&id=<?php echo $c['pk_i_id']; ?>" onclick="return confirm('Are you sure you want to delete this category? This will remove all boards, topics and post in this category. Action cannot be undone.')" class="mb-remove mb-btn mb-button-red"><i class="fa fa-trash-o"></i> <span><?php echo __('Remove', 'forums'); ?></span></a>
                  <?php } else { ?>
                    <a href="#" onclick="return false;" class="mb-remove mb-btn mb-button-red frm-has-tooltip-right mb-disabled" style="opacity:0.5;cursor:not-allowed;" disabled title="<?php echo osc_esc_html(__('This is demo site', 'forums')); ?>"><i class="fa fa-trash-o"></i> <span><?php echo __('Remove', 'forums'); ?></span></a>
                  <?php } ?>
                </div>
              </div>
            <?php } ?>
          <?php } else { ?>
            <div class="mb-table-row mb-row-empty">
              <i class="fa fa-warning"></i><span><?php _e('No categories has been created yet', 'forums'); ?></span>
            </div>
          <?php } ?>
        </div>

        <div class="mb-row">&nbsp;</div>

        <div class="mb-category-placeholder" style="display:none;">
          <div class="mb-table-row">
            <div class="mb-col-1 mb-col-id mb-input-box"><input type="text" name="cat_id_" value="" readonly="readonly" placeholder="xx"></div>
            <div class="mb-col-20 mb-col-name mb-input-box mb-align-left"><input type="text" name="cat_name_" value="" placeholder="<?php echo osc_esc_html(__('New category', 'forums')); ?>"></div>
            <div class="mb-col-3 mb-col-del"><a href="#" class="mb-remove mb-btn mb-button-red new-category-remove"><i class="fa fa-trash-o"></i> <span><?php echo __('Remove', 'forums'); ?></span></a></div>
          </div>
        </div>

        <a class="mb-button-green mb-new-category" href="#"><i class="fa fa-plus-circle"></i> <?php _e('Add a new category', 'forums'); ?></a>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!frm_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'forums');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>
</div>


<?php echo frm_footer(); ?>