<?php
  // Create menu
  $title = __('Configure', 'forums');
  frm_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value
  $topics_per_page = mb_param_update('topics_per_page', 'plugin_action', 'value', 'plugin-forums');
  $posts_per_page = mb_param_update('posts_per_page', 'plugin_action', 'value', 'plugin-forums');
  $hook_header_links = mb_param_update('hook_header_links', 'plugin_action', 'check', 'plugin-forums');
  $sanitize = mb_param_update('sanitize', 'plugin_action', 'check', 'plugin-forums');
  $logged_users_only = mb_param_update('logged_users_only', 'plugin_action', 'check', 'plugin-forums');

  // colors
  $links_color = mb_param_update('links_color', 'plugin_action_color', 'value', 'plugin-forums');
  $category_color = mb_param_update('category_color', 'plugin_action_color', 'value', 'plugin-forums');
  $button1_color = mb_param_update('button1_color', 'plugin_action_color', 'value', 'plugin-forums');
  $button2_color = mb_param_update('button2_color', 'plugin_action_color', 'value', 'plugin-forums');
  
  $links_color = ($links_color <> '' ? $links_color : '#33659C');
  $category_color = ($category_color <> '' ? $category_color : '#437dbf');
  $button1_color = ($button1_color <> '' ? $button1_color : '#9cc845');
  $button2_color = ($button2_color <> '' ? $button2_color : '#333333');


  if(Params::getParam('plugin_action') == 'done') {
    message_ok( __('Settings were successfully saved', 'forums') );
  }

  if(Params::getParam('plugin_action_color') == 'done') {
    message_ok( __('Color settings were successfully saved', 'forums') );
  }

  // GENERATE SITEMAP
  if(Params::getParam('frmSitemap') == 'generate') {
    $execution_time = frm_generate_sitemap();
    message_ok(__('Sitemap generated correctly in', 'forums') . ' ' . round($execution_time, 2) . ' ' . __('seconds', 'forums') . '.<br/>' . osc_base_url() . 'sitemap_forums.xml');
  }

?>



<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Configure', 'forums'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action" value="done" />


        <div class="mb-row">
          <label for="topics_per_page"><span><?php _e('Topics per Page', 'forums'); ?></span></label> 
          <input type="text" size="6" name="topics_per_page" id="topics_per_page" value="<?php echo $topics_per_page; ?>"/>
          <div class="mb-input-desc"><?php _e('topics', 'forums'); ?></div>

          <div class="mb-explain"><?php _e('Enter how many topics are shown per page (pagination).', 'forums'); ?></div>
        </div>


        <div class="mb-row">
          <label for="posts_per_page"><span><?php _e('Posts per Page', 'forums'); ?></span></label> 
          <input type="text" size="6" name="posts_per_page" id="posts_per_page" value="<?php echo $posts_per_page; ?>"/>
          <div class="mb-input-desc"><?php _e('posts', 'forums'); ?></div>

          <div class="mb-explain"><?php _e('Enter how many posts are shown per page (pagination).', 'forums'); ?></div>
        </div>

        <div class="mb-row">
          <label for="hook_header_links"><span><?php _e('Hook Button to Header', 'forums'); ?></span></label> 
          <input type="checkbox" name="hook_header_links" id="hook_header_links" class="element-slide" <?php echo ($hook_header_links == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, "Forums" button/link is added into header. Require Osclass 8.2 theme hooks support.', 'forums'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="sanitize"><span><?php _e('Sanitize URL strings', 'forums'); ?></span></label> 
          <input type="checkbox" name="sanitize" id="sanitize" class="element-slide" <?php echo ($sanitize == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, plugin will try to sanitize text in URLs. Otherwise only Osclass built-in sanitization is used.', 'forums'); ?></div>
            <div class="mb-line"><?php _e('Try to disable when using with non-latin characters (Cyrillic, Greek, ...', 'forums'); ?></div>
          </div>
        </div>

        <div class="mb-row">
          <label for="logged_users_only"><span><?php _e('Logged Users Only', 'forums'); ?></span></label> 
          <input type="checkbox" name="logged_users_only" id="logged_users_only" class="element-slide" <?php echo ($logged_users_only == 1 ? 'checked' : ''); ?>/>
          
          <div class="mb-explain">
            <div class="mb-line"><?php _e('When enabled, forums will be available to logged-in users only. Not logged users will not be able to access forums and will be redirected to login page.', 'forums'); ?></div>
          </div>
        </div>


        <div class="mb-row">&nbsp;</div>


        <div class="mb-row">
          <label><span><?php _e('Sitemap', 'forums'); ?></span></label> 
          <a class="mb-button-green mb-regenerate" href="<?php echo osc_admin_base_url(true); ?>?page=plugins&action=renderplugin&file=forums/admin/configure.php&frmSitemap=generate"><?php _e('Regenerate sitemap now', 'forums'); ?></a>

          <div class="mb-explain"><?php _e('Sitemap is regenerated automatically via cron daily.', 'forums'); ?></div>
        </div>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!frm_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'forums');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>




  <!-- COLORS SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-wrench"></i> <?php _e('Colors', 'forums'); ?>
    </div>

    <div class="mb-inside">
      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>configure.php" />
        <input type="hidden" name="plugin_action_color" value="done" />

        <div class="mb-row mb-color-box">
          <label for="links_color"><span><?php _e('Links Color', 'forums'); ?></span></label> 
          
          <input name="links_color" id="links_color" size="20" type="text" value="<?php echo osc_esc_html($links_color); ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo osc_esc_html($links_color); ?>" />
          </span>
          <div class="mb-explain"><?php _e('Enter color in HEX format or select color with picker. Example: #33659C', 'forums'); ?></div>
        </div>


        <div class="mb-row mb-color-box">
          <label for="category_color"><span><?php _e('Category Header Color', 'forums'); ?></span></label> 
          
          <input name="category_color" id="category_color" size="20" type="text" value="<?php echo osc_esc_html($category_color); ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo osc_esc_html($category_color); ?>" />
          </span>
          <div class="mb-explain"><?php _e('Enter color in HEX format or select color with picker. Example: #437dbf', 'forums'); ?></div>
        </div>

        <div class="mb-row mb-color-box">
          <label for="button1_color"><span><?php _e('Create Topic Button Color', 'forums'); ?></span></label> 
          
          <input name="button1_color" id="button1_color" size="20" type="text" value="<?php echo osc_esc_html($button1_color); ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo osc_esc_html($button1_color); ?>" />
          </span>
          <div class="mb-explain"><?php _e('Enter color in HEX format or select color with picker. Example: #9cc845', 'forums'); ?></div>
        </div>

        <div class="mb-row mb-color-box">
          <label for="button2_color"><span><?php _e('Dark/Black Buttons Color', 'forums'); ?></span></label> 
          
          <input name="button2_color" id="button2_color" size="20" type="text" value="<?php echo osc_esc_html($button2_color); ?>" />
          <span class="color-wrap">
            <input name="color-picker" id="" type="color" value="<?php echo osc_esc_html($button2_color); ?>" />
          </span>
          <div class="mb-explain"><?php _e('Enter color in HEX format or select color with picker. Example: #333333', 'forums'); ?></div>
        </div>
        

        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!frm_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'forums');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>




  <!-- PLUGIN INTEGRATION -->
  <div class="mb-box">
    <div class="mb-head"><i class="fa fa-wrench"></i> <?php _e('Plugin Setup', 'forums'); ?></div>

    <div class="mb-inside">
      <div class="mb-row"><?php _e('No theme modification are required to use all functions of plugin, it is required only to show link/button to your forums', 'forums'); ?></div>
      <div class="mb-row">
        <strong><?php _e('Button', 'forums'); ?></strong>
        <span class="mb-code">&lt;?php if(function_exists('frm_home')) { echo frm_home(); } ?&gt;</span>
      </div>
      
      <div class="mb-row">
        <strong><?php _e('Widget - Last active topics on forums', 'forums'); ?></strong>
        <span class="mb-code">&lt;?php if(function_exists('frm_last_active_topics')) { frm_last_active_topics(); } ?&gt;</span>
      </div>
      
      <div class="mb-row">
        <strong><?php _e('Widget - Lately created topics on forums', 'forums'); ?></strong>
        <span class="mb-code">&lt;?php if(function_exists('frm_last_created_topics')) { frm_last_created_topics(); } ?&gt;</span>
      </div>
    </div>
  </div>
</div>


<?php echo frm_footer(); ?>