<?php
  // Create menu
  $title = __('Layout', 'forums');
  frm_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value


  $categories = ModelFRM::newInstance()->getCategories();
?>



<div class="mb-body">

  <div class="mb-message-js"></div>


  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-list"></i> <?php _e('Layout', 'forums'); ?>
    </div>

    <div class="mb-inside mb-category">
      <div id="mb-category">
        <?php if(count($categories) > 0) { ?>
          <?php foreach($categories as $c) { ?>
            <?php
              $boards = ModelFRM::newInstance()->getBoards($c['pk_i_id'], 0);
              $count = ModelFRM::newInstance()->countCategoryBoards($c['pk_i_id']);
            ?>


            <div class="mb-frm-cat" data-id="<?php echo $c['pk_i_id']; ?>" id="<?php echo $c['pk_i_id']; ?>">
              <div class="mb-top-line">
                <span class="move"><i class="fa fa-arrows"></i></span>
                <span class="name"><?php echo (frm_name($c) <> '' ? frm_name($c) : __('New category', 'forums')); ?></span>
                <span class="count"><?php echo $count .  ' ' . ($count == 1 ? __('board', 'forums') : __('boards', 'forums')); ?></span>
                <span class="show"><i class="fa fa-angle-down"></i></span>
              </div>

              <div class="mb-frm-boards">
                <?php if(count($boards) > 0) { ?>
                  <ol class="sortable is-tree">
                    <?php frm_board_list_ol($boards); ?>
                  </ol>
                <?php } else { ?>
                  <div class="mb-no-board"><?php _e('You have not added any boards into this category yet', 'forums'); ?></div>
                <?php } ?>
              </div>

            </div>

          <?php } ?>
        <?php } else { ?>
          <div class="mb-no-category"><?php _e('You have not created any categories yet', 'forums'); ?></div>
        <?php } ?>
      </div>
  </div>
</div>



<script type="text/javascript">
  var frm_category_position_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=frm_category_position";
  var frm_board_position_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=frm_board_position";


  var frm_message_ok = "<?php echo osc_esc_html(__('Success!', 'forums')); ?>";
  var frm_message_wait = "<?php echo osc_esc_html(__('Updating, please wait...', 'forums')); ?>";
  var frm_message_error = "<?php echo osc_esc_html(__('Error!', 'forums')); ?>";


  var board_list = '';

  // SORTABLE BOARDS
  $(document).ready(function(){
    $('ol.sortable').nestedSortable({
      forcePlaceholderSize: true,
      handle: 'div',
      helper: 'clone',
      items: 'li',
      opacity: .8,
      placeholder: 'frm-placeholder',
      revert: 100,
      tabSize: 5,
      tolerance: 'intersect',
      toleranceElement: '> div',
      maxLevels: 8,
      isTree: true,
      startCollapsed: false,
      start: function(event, ui) {
        board_list = $(this).nestedSortable('serialize');
        ui.placeholder.height(ui.item.find('>div').innerHeight() - 2);
      },
      stop: function (event, ui) {
        var c_board_list = $(this).nestedSortable('serialize');
        var c_array_list = $(this).nestedSortable('toArray');

        var c_array_list = c_array_list.reduce(function(total, current, index) {
          total[index] = {'c' : current.item_id, 'p' : current.parent_id};
          return total;
        }, {});


        frm_message(frm_message_wait, 'info');

        if(board_list != c_board_list) {
          $.ajax({
            url: frm_board_position_url,
            type: "POST",
            data: {'list' : JSON.stringify(c_array_list)},
            success: function(response){
              //console.log(response);
              frm_message(frm_message_ok, 'ok');
            },
            error: function(response) {
              frm_message(frm_message_error, 'error');
              console.log(response);
            }
          });
        }
      }
    });



    var category_list = '';

    $('#mb-category').sortable({
      axis: "y",
      forcePlaceholderSize: true,
      handle: '.mb-top-line',
      helper: 'clone',
      items: '.mb-frm-cat',
      opacity: .8,
      placeholder: 'frm-placeholder',
      revert: 100,
      tabSize: 5,
      tolerance: 'intersect',
      start: function(event, ui) {
        category_list = $(this).sortable('toArray');
      },
      stop: function (event, ui) {
        var c_category_list = $(this).sortable('toArray');

        var c_category_list = c_category_list.reduce(function(total, current, index) {
          total[index] = {'c' : current};
          return total;
        }, {});

        frm_message(frm_message_wait, 'info');

        if(category_list != c_category_list) {

          $.ajax({
            url: frm_category_position_url,
            type: "GET",
            data: {'list' : JSON.stringify(c_category_list)},
            success: function(response){
              //console.log(response);
              frm_message(frm_message_ok, 'ok');
            },
            error: function(response) {
              frm_message(frm_message_error, 'error');
              console.log(response);
            }
          });
        }
      }
    });

  });
</script>


<?php echo frm_footer(); ?>
