<?php
  // Create menu
  $title = __('Users', 'forums');
  frm_menu($title);


  // GET & UPDATE PARAMETERS
  // $variable = mb_param_update( 'param_name', 'form_name', 'input_type', 'plugin_var_name' );
  // input_type: check or value


  if(frm_is_demo()) {
    message_error( __('This is demo site, you cannot manage users.', 'forums') );
  }


  if(Params::getParam('plugin_action') == 'done' && !frm_is_demo()) {
    $users = ModelFRM::newInstance()->getSuperUsers();

    if(count($users) > 0) {
      foreach($users as $u) {
        $data = array();

        $data['s_username'] = Params::getParam('user_name_' . $u['pk_i_id']);
        $data['b_admin'] = (Params::getParam('user_admin_' . $u['pk_i_id']) == 'on' ? 1 : Params::getParam('user_admin_' . $u['pk_i_id']));
        $data['b_moderator'] = (Params::getParam('user_moderator_' . $u['pk_i_id']) == 'on' ? 1 : Params::getParam('user_moderator_' . $u['pk_i_id']));

        ModelFRM::newInstance()->updateUserData($u['pk_i_id'], $data);
      }
    }

    message_ok( __('Users were successfully updated', 'forums') );
  }



  // ADD SUPERUSER
  if(Params::getParam('plugin_action') == 'superuser') {
    $data = array();

    $data['s_username'] = Params::getParam('name');
    $data['b_admin'] = (Params::getParam('admin') == 'on' ? 1 : Params::getParam('admin'));
    $data['b_moderator'] = (Params::getParam('moderator') == 'on' ? 1 : Params::getParam('moderator'));

    ModelFRM::newInstance()->updateUserData(Params::getParam('id'), $data);

    message_ok( __('Superuser were successfully updated', 'forums') );
  }


  $users = ModelFRM::newInstance()->getSuperUsers();
?>



<div class="mb-body">

  <!-- CONFIGURE SECTION -->
  <div class="mb-box">
    <div class="mb-head">
      <i class="fa fa-user"></i> <?php _e('Users', 'forums'); ?>
    </div>

    <div class="mb-inside">
      <div class="mb-row mb-notes">
        <div class="mb-line"><?php _e('If user will not have role admin nor moderator, it will be removed from list of super users automatically.', 'forums'); ?></div>
        <div class="mb-line"><?php _e('Moderators have privileges just in boards these users are selected as moderators. To do so, go to Boards section and add moderators there as well.', 'forums'); ?></div>
      </div>


      <form name="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data" >
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>user.php" />
        <input type="hidden" name="plugin_action" value="done" />


        <div class="mb-table mb-table-user">
          <div class="mb-table-head">
            <div class="mb-col-2"><?php _e('ID', 'forums'); ?></div>
            <div class="mb-col-3 mb-input-box mb-align-left"><?php _e('Forum Name', 'forums'); ?></div>
            <div class="mb-col-3 mb-input-box"><?php _e('Is Admin', 'forums'); ?></div>
            <div class="mb-col-3 mb-input-box"><?php _e('Is Moderator', 'forums'); ?></div>
            <div class="mb-col-2 mb-input-box mb-align-left"><?php _e('Profile Name', 'forums'); ?></div>
            <div class="mb-col-4 mb-input-box mb-align-left"><?php _e('Email', 'forums'); ?></div>
            <div class="mb-col-2 mb-input-box"><?php _e('Topics', 'forums'); ?></div>
            <div class="mb-col-2 mb-input-box"><?php _e('Posts', 'forums'); ?></div>
            <div class="mb-col-3 mb-input-box"><?php _e('Last Active', 'forums'); ?></div>
          </div>

          <?php if(count($users) > 0) { ?>
            <?php foreach($users as $u) { ?>
              <div class="mb-table-row">
                <div class="mb-col-2 mb-col-id mb-input-box"><input type="text" name="user_id_<?php echo $u['pk_i_id']; ?>" value="<?php echo $u['pk_i_id']; ?>" readonly="readonly"></div>
                <div class="mb-col-3 mb-col-name mb-input-box"><input type="text" name="user_name_<?php echo $u['pk_i_id']; ?>" value="<?php echo $u['s_username']; ?>"></div>
                <div class="mb-col-3 mb-col-admin mb-input-box"><input name="user_admin_<?php echo $u['pk_i_id']; ?>" type="checkbox" class="element-slide" <?php echo ($u['b_admin'] == 1 ? 'checked' : ''); ?> /></div>
                <div class="mb-col-3 mb-col-moderator mb-input-box"><input name="user_moderator_<?php echo $u['pk_i_id']; ?>" type="checkbox" class="element-slide" <?php echo ($u['b_moderator'] == 1 ? 'checked' : ''); ?> /></div>
                <div class="mb-col-2 mb-col-osname mb-input-box mb-align-left"><span><?php echo $u['s_name']; ?></span></div>
                <div class="mb-col-4 mb-col-email mb-input-box mb-align-left"><span><?php echo $u['s_email']; ?></span></div>
                <div class="mb-col-2 mb-col-topics mb-input-box"><span><?php echo $u['i_num_topics']; ?></span></div>
                <div class="mb-col-2 mb-col-posts mb-input-box"><span><?php echo $u['i_num_posts']; ?></span></div>
                <div class="mb-col-3 mb-col-active mb-input-box"><span><?php echo date('j. M Y', strtotime($u['dt_last_active'])); ?></span></div>
              </div>
            <?php } ?>
          <?php } else { ?>
            <div class="mb-table-row mb-row-empty">
              <i class="fa fa-warning"></i><span><?php _e('No super users has been added yet', 'forums'); ?></span>
            </div>
          <?php } ?>
        </div>


        <div class="mb-row">&nbsp;</div>

        <div class="mb-foot">
          <?php if(!frm_is_demo()) { ?><button type="submit" class="mb-button"><?php _e('Save', 'forums');?></button><?php } ?>
        </div>
      </form>
    </div>
  </div>


  <!-- ADD FUNDS TO USER -->
  <div class="mb-box mb-superuser">
    <div class="mb-head"><i class="fa fa-plus-circle"></i> <?php _e('Add forum user to superuser list', 'forums'); ?></div>

    <div class="mb-inside">
      <form name="promo_form" id="promo_form" action="<?php echo osc_admin_base_url(true); ?>" method="POST" enctype="multipart/form-data">
        <input type="hidden" name="page" value="plugins" />
        <input type="hidden" name="action" value="renderplugin" />
        <input type="hidden" name="file" value="<?php echo osc_plugin_folder(__FILE__); ?>user.php" />
        <input type="hidden" name="plugin_action" value="superuser" />


        <div class="mb-row mb-notes">
          <div class="mb-line"><?php _e('Create superuser from standard user, just start typing user name into name field.', 'forums'); ?></div>
        </div>

        <?php
          if(Params::getParam('plugin_action') == 'superuser') {
            $email = trim(strtolower(Params::getParam('email')));
            $osclass_user = User::newInstance()->findByEmail($email);
            $user = ModelFRM::newInstance()->getUser($osclass_user['pk_i_id']);
          }
        ?>


        <div class="mb-row mb-user-lookup">
          <div class="mb-line mb-error-block"></div>

          <div class="mb-line">
            <label for="id"><span><?php _e('User ID', 'forums'); ?></span></label>
            <input type="text" size="12" id="id" name="id" readonly="readonly" value="<?php echo (isset($user['pk_i_id']) ? $user['pk_i_id'] : ''); ?>"/>
          </div>

          <div class="mb-line">
            <label for="name"><span><?php _e('Name', 'forums'); ?></span></label>
            <input type="text" size="80" id="name" name="name" placeholder="<?php echo osc_esc_html(__('Type user name or email...', 'forums')); ?>" value="<?php echo osc_esc_html(isset($user['s_name']) ? frm_user_name($user) : ''); ?>"/>
            <div class="mb-explain"><?php _e('Start typing user name or email and select user you want to check from list.', 'forums'); ?></div>
          </div>

          <div class="mb-line">
            <label for="email"><span><?php _e('Email', 'forums'); ?></span></label>
            <input type="text" size="40" id="email" name="email" readonly="readonly" value="<?php echo (isset($user['s_email']) ? $user['s_email'] : ''); ?>"/>
          </div>

          <div class="mb-line">
            <label for="admin"><span><?php _e('Is Admin', 'forums'); ?></span></label>
            <input type="checkbox" id="admin" name="admin" class="element-slide" <?php echo (@$user['b_admin'] == 1 ? 'checked="checked"' : '') ?> value="1"/>
          </div>

          <div class="mb-line">
            <label for="moderator"><span><?php _e('Is Moderator', 'forums'); ?></span></label>
            <input type="checkbox" id="moderator" name="moderator" class="element-slide" <?php echo (@$user['b_moderator'] == 1 ? 'checked="checked"' : '') ?> value="1"/>
          </div>

          <div class="mb-row"><div class="mb-line">&nbsp;</div><div class="mb-line" style="border-top:1px solid rgba(0,0,0,0.1);">&nbsp;</div></div>


          <div class="mb-line">
            <label><span>&nbsp;</span></label>
            <button type="submit" class="mb-button-green"><i class="fa fa-check"></i> <?php _e('Update user', 'forums');?></button>
          </div>

          <div class="mb-row">&nbsp;</div>

        </div>
      </form>
    </div>
  </div>

</div>


<script type="text/javascript">
  var user_lookup_error = "<?php echo osc_esc_js(__('Error getting data, user not found', 'forums')); ?>";
  var user_lookup_url = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=runhook&hook=frm_superuser&id=";
  var user_lookup_base = "<?php echo osc_admin_base_url(true); ?>?page=ajax&action=userajax";
</script>



<?php echo frm_footer(); ?>