<?php
  $type = trim(Params::getParam('type'));
  $type = ($type == '' ? 'most-recent' : $type);

  if(!in_array($type, array('latest', 'unread'))) {
    header('Location:' . osc_route_url('frm-home'));
    exit;
  }

  $page_id = Params::getParam('pageId');
  $page_id = ($page_id > 0 ? $page_id : 1);
  $per_page = frm_param('posts_per_page');

  $limit = array($per_page, $page_id);

  $posts = ModelFRM::newInstance()->getPostsByActivityType($type, $limit);
  $count = ModelFRM::newInstance()->countPostsByActivityType($type);
  
  if(osc_is_web_user_logged_in()) {
    $logged = ModelFRM::newInstance()->getUser(osc_logged_user_id());
  } else {
    $logged = false;
  }
?>

<div id="frm-body" class="frm-body frm-theme-<?php echo osc_current_web_theme(); ?>">
  <div id="frm-main">
    <div class="frm-content">
      <?php echo frm_breadcrumbs(); ?>

      <div class="frm-title-left">
        <h1>
          <?php 
            if($type == 'latest') {
              _e('Most recent posts', 'forums');
            } else if ($type == 'unread') {
              _e('Latest unread posts', 'forums');
            }
          ?>
        </h1>
      </div>

      <div class="frm-title-right">
        <form action="<?php echo osc_route_url('frm-search-pre'); ?>" method="POST" class="nocsrf">
          <input type="hidden" name="frmAction" value="search" />
          <input type="text" name="searchWord" value="" id="frm-keyword" placeholder="<?php echo osc_esc_html(__('Keyword', 'forums')); ?>"/>
          <button type="submit"><i class="fa fa-search"></i></button>
        </form>
      </div>

      <!-- TOP PAGINATION -->
      <?php if(count($posts) > 0) { ?>
        <?php echo frm_paginate('', '', '', 'activity', $page_id, $per_page, $count, 'frm-pagination-topic'); ?>
      <?php } ?>

      <div class="frm-posts">
        <?php 
          if($type == 'unread' && !osc_is_web_user_logged_in()) { 
          ?>
            <div class="frm-answer frm-search-empty">
              <div class="frm-unlogged-title"><?php _e('Unread posts not available', 'forums'); ?></div>
              <div class="frm-unlogged-subtitle"><?php _e('Please login to see your unread posts', 'forums'); ?></div>
            </div>
          <?php
          } else if(count($posts) > 0) {
            foreach($posts as $post) {
              $board = ModelFRM::newInstance()->getBoard($post['fk_i_board_id']);
              $topic = ModelFRM::newInstance()->getTopic($post['fk_i_topic_id']);

              // Check if user can see this topic
              if(frm_control_user(osc_logged_user_id(), $board)) {
                frm_generate_post($board, $topic, $post, 0, 'activity', array(), $logged);
              } else {
                ?>
                <div class="frm-post frm-restricted">
                  <div class="frm-row"><?php echo _e('This board is available only to premium members', 'forums'); ?></div>
                  <div class="frm-row"><?php _e('You have to be member of one of following groups to have access there:', 'forums'); ?> <strong><?php echo frm_board_groups($board); ?></strong></div>
                </div>
                <?php
              }
            }
          } else {
            ?>
            <div class="frm-answer frm-search-empty">
              <?php if($type == 'latest') { ?>
                <div class="frm-unlogged-title"><?php _e('No latest posts found', 'forums'); ?></div>
              <?php } else if($type == 'unread') { ?>
                <div class="frm-unlogged-title"><?php _e('No unread posts found', 'forums'); ?></div>
              <?php } ?>
            </div>
            <?php
          }
        ?>
      </div>


      <!-- BOTTOM PAGINATION -->
      <?php if(count($posts) > 0) { ?>
        <?php echo frm_paginate('', '', '', 'activity', $page_id, $per_page, $count, 'frm-pagination-topic'); ?>
      <?php } ?>

    </div>
  </div>
</div>