<?php
  if(function_exists('osc_get_current_url') && osc_route_url('frm-home') != osc_get_current_url() && Params::getParam('rd') != 1) {
    header('Location:' . osc_route_url('frm-home') . '?rd=1');
    exit;
  }
  
  $categories = ModelFRM::newInstance()->getCategories();
?>


<div id="frm-body" class="frm-body frm-theme-<?php echo osc_current_web_theme(); ?>">
  <div id="frm-main">
    <?php if(frm_param('welcome_text') <> '') { ?>
      <div class="frm-welcome">
        <?php echo frm_param('welcome_text'); ?>
      </div>
    <?php } ?>

    <div class="frm-content">
      <?php echo frm_breadcrumbs(); ?>

      <div class="frm-title-left">
        <h1><?php _e('Forums', 'forums'); ?></h1>
      </div>

      <div class="frm-title-right">
        <form action="<?php echo osc_route_url('frm-search-pre'); ?>" method="POST" class="nocsrf">
          <input type="hidden" name="frmAction" value="search" />
          <input type="text" name="searchWord" id="frm-keyword" placeholder="<?php echo osc_esc_html(__('Keyword', 'forums')); ?>" />
          <button type="submit"><i class="fa fa-search"></i></button>
        </form>
      </div>

      <?php if(count($categories) > 0) { ?>
        <?php foreach($categories as $category) { ?>
          <div class="frm-box">
            <div class="frm-category">
              <div class="frm-c-name"><?php echo frm_name($category); ?></div>
            </div>

            <?php $boards = ModelFRM::newInstance()->getBoards($category['pk_i_id']); ?>

            <div class="frm-boards">
              <?php if(count($boards) > 0) { ?>
                <?php foreach($boards as $board) { ?>
                  <div class="frm-board<?php if($board['i_viewed'] == 0 && osc_is_web_user_logged_in()) { ?> frm-unread<?php } ?>">
                    <div class="frm-icon">
                      <div class="frm-icon-outer">
                        <i class="fa fa-comments"></i>
                      </div>
                    </div>

                    <div class="frm-about">
                      <div class="frm-name"><a href="<?php echo frm_board_url($board); ?>"><?php echo frm_name($board); ?></a></div>

                      <?php if(isset($board['children']) && count($board['children']) > 0) { ?>
                        <div class="frm-subboards">
                          <div class="frm-square"></div>

                          <?php foreach($board['children'] as $subboard) { ?>
                            <a href="<?php echo frm_board_url($subboard); ?>"><?php echo frm_name($subboard); ?></a>
                          <?php } ?>
                        </div>
                      <?php } ?>

                      <div class="frm-desc"><?php echo frm_description($board); ?></div>
                    </div>

                    <div class="frm-stats">
                      <strong><?php echo $board['i_num_topics']; ?></strong>
                      <span><?php echo ($board['i_num_topics'] == 1 ? __('topic', 'forums') : __('topics', 'forums')); ?></span>
                    </div>

                    <div class="frm-last">
                      <?php if($board['fk_i_last_topic_id'] > 0) { ?>
                        <?php
                          $last_topic = ModelFRM::newInstance()->getTopic($board['fk_i_last_topic_id']);
                          $last_user = ModelFRM::newInstance()->getUser($board['fk_i_last_user_id']);
                          $last_user_img = frm_user_img($last_user);
                        ?>

                        <?php if(isset($last_topic['pk_i_id'])) { ?>
                          <div class="frm-user-icon"><img src="<?php echo $last_user_img; ?>" /></div>
                          <div class="frm-last-topic">
                            <div class="frm-last-title"><a href="<?php echo frm_topic_url($last_topic); ?>"><?php echo osc_highlight($last_topic['s_title'], 40); ?></a></div>
                            <div class="frm-last-user"><?php _e('By', 'forums'); ?> <a href="<?php echo frm_user_url($last_user); ?>"><?php echo frm_user_name($last_user); ?></a></div>
                            <div class="frm-last-date"><?php echo date('j. M Y', strtotime($board['dt_last_post_date'])); ?></div>
                          </div>
                        <?php } ?>
                      <?php } ?>
                    </div>
   
                  </div>
                <?php } ?>
              <?php } else { ?>
                <div class="frm-empty frm-empty-board"><?php _e('There are no boards yet', 'forums'); ?></div>
              <?php } ?>
            </div>
          </div>
        <?php } ?>
      <?php } else { ?>
        <div class="frm-empty frm-empty-category"><?php _e('There are no categories yet', 'forums'); ?></div>
      <?php } ?>
    </div>
  </div>
</div>