<?php
  $user_id = Params::getParam('userId');
  $user = ModelFRM::newInstance()->getUser($user_id);

  if(osc_is_web_user_logged_in()) {
    $logged = ModelFRM::newInstance()->getUser(osc_logged_user_id());
  } else {
    $logged = false;
  }

  if(!$logged) {
    osc_add_flash_error_message(__('Please login to access user profile section', 'forums'));
    header('Location:' . osc_route_url('frm-home'));
    exit;

  } else if($user_id <> osc_logged_user_id() && $logged['b_admin'] <> 1) {
    osc_add_flash_error_message(__('You are not authorized to access this profile', 'forums'));
    header('Location:' . osc_route_url('frm-home'));
    exit;
  }


  // CREATE PROFILE IF DOES NOT EXIST
  if(!isset($user['fk_i_user_id']) || $user['fk_i_user_id'] <= 0) {
    ModelFRM::newInstance()->insertUser($user_id);
    $user = ModelFRM::newInstance()->getUser($user_id);
  }


  // UPDATE PROFILE
  if(Params::getParam('frmAction') == 'update') {
    $data = array(
      'fk_i_user_id' => $user_id,
      //'s_image' => $user['s_image'],
      's_username' => Params::getParam('s_username'),
      's_title' => Params::getParam('s_title'),
      's_motto' => Params::getParam('s_motto'),
      's_website' => Params::getParam('s_website'),
      's_signature' => Params::getParam('s_signature')
    );


    ModelFRM::newInstance()->updateUser($data, Params::getFiles('frmImage'));
    osc_add_flash_ok_message(__('Forum profile has been successfully updated', 'forums'));

    header('Location:' . osc_route_url('frm-profile', array('userId' => $user_id)));
    exit;

  }
?>



<div id="frm-body" class="frm-body frm-theme-<?php echo osc_current_web_theme(); ?>">
  <div id="frm-main">
    <div class="frm-content frm-profile">
      <?php echo frm_breadcrumbs(); ?>

      <h1><?php echo sprintf(__('%s\'s profile', 'forums'), frm_user_name($user)); ?></h1>
      <h2><?php _e('Update your forum profile there', 'forums'); ?></h2>

      <div class="frm-user-data">
        <form class="frm-inside" action="<?php echo osc_route_url('frm-profile', array('userId' => $user_id)); ?>" method="POST" enctype="multipart/form-data">
          <input type="hidden" name="frmAction" value="update" />

          <div class="frm-row frm-picture">
            <label for="frmImage"><?php _e('Profile picture', 'forums'); ?>:</label>
            <div class="frm-input-box frm-file">
              <div class="frm-user-img">
                <img src="<?php echo frm_user_img($user); ?>" />
              </div>

              <div class="frm-attachment frm-has-tooltip" title="<?php echo osc_esc_js(sprintf(__('Maximum file size is %skb. Allowed extensions: %s. Recommended size is 125x125 px.', 'forums'), 1024, '.jpg, .jpeg, .png, .gif')); ?>">
                <div class="frm-att-box">
                  <label class="frm-status">
                    <span class="frm-wrap"><i class="fa fa-upload"></i> <span><?php _e('Upload picture', 'forums'); ?></span></span>
                    <input type="file" name="frmImage" id="frmImage" class="frm-attachment" />
                  </label>
                </div>
              </div>
            </div>
          </div>


          <div class="frm-row">
            <label for=""><?php _e('Rank', 'forums'); ?>:</label>
            <div class="frm-input-box"><strong style="color:<?php echo frm_user_rank($user, 'color'); ?>" class="frm-profile-rank"><?php echo frm_user_rank($user, 'name'); ?></strong></div>
          </div>

          <div class="frm-row">
            <label for="s_username"><?php _e('Forum name', 'forums'); ?>:</label>
            <div class="frm-input-box"><input id="s_username" name="s_username" type="text" value="<?php echo $user['s_username']; ?>"/></div>
          </div>

          <div class="frm-row">
            <label for="s_title"><?php _e('Title / Position', 'forums'); ?>:</label>
            <div class="frm-input-box"><input id="s_title" name="s_title" type="text" value="<?php echo $user['s_title']; ?>"/></div>
          </div>

          <div class="frm-row">
            <label for="s_motto"><?php _e('Motto', 'forums'); ?>:</label>
            <div class="frm-input-box"><input id="s_motto" name="s_motto" type="text" value="<?php echo $user['s_motto']; ?>"/></div>
          </div>

          <div class="frm-row">
            <label for="s_website"><?php _e('Website', 'forums'); ?>:</label>
            <div class="frm-input-box"><input id="s_website" name="s_website" type="text" value="<?php echo $user['s_website']; ?>"/></div>
          </div>

          <div class="frm-row">
            <label for="s_signature"><?php _e('Signature', 'forums'); ?>:</label>
            <div class="frm-input-box frm-textarea"><textarea id="s_signature" name="s_signature"><?php echo $user['s_signature']; ?></textarea></div>
          </div>

          <div class="frm-row">
            <label class="frm-button-label">&nbsp;</label>
            <div class="frm-input-box"><button type="submit" class="frm-update-profile"><?php _e('Update profile', 'forums'); ?></button></div>
          </div>

        </form>
      </div>

    </div>
  </div>
</div>