<?php
  $user_id = Params::getParam('userId');
  $user = ModelFRM::newInstance()->getUser($user_id);

  if(!isset($user['fk_i_user_id']) || $user['fk_i_user_id'] <= 0) {
    osc_add_flash_error_message(__('This user does not exists anymore', 'forums'));

    header('Location:' . osc_route_url('frm-home'));
    exit;
  }
  
  $page_id = Params::getParam('pageId');
  $page_id = ($page_id > 0 ? $page_id : 1);
  $per_page = frm_param('posts_per_page');

  $limit = array($per_page, $page_id);

  $posts = ModelFRM::newInstance()->getPostsByUser($user_id, $limit);

  if(osc_is_web_user_logged_in()) {
    $logged = ModelFRM::newInstance()->getUser(osc_logged_user_id());
  } else {
    $logged = false;
  }
?>



<div id="frm-body" class="frm-body frm-theme-<?php echo osc_current_web_theme(); ?>">
  <div id="frm-main">
    <div class="frm-content">
      <?php echo frm_breadcrumbs(); ?>

      <h1><?php echo sprintf(__('%s board', 'forums'), frm_user_name($user)); ?></h1>
      <h2><?php _e('All comments & posts, starting from most recent posts', 'forums'); ?></h2>


      <!-- TOP PAGINATION -->
      <?php echo frm_paginate('', '', $user, 'user', $page_id, $per_page, @$user['i_num_posts'], 'frm-pagination-topic'); ?>


      <div class="frm-posts">
        <?php 
          foreach($posts as $post) {
            $board = ModelFRM::newInstance()->getBoard($post['fk_i_board_id']);
            $topic = ModelFRM::newInstance()->getTopic($post['fk_i_topic_id']);

            // Check if user can see this topic
            if(frm_control_user(osc_logged_user_id(), $board)) {
              frm_generate_post($board, $topic, $post, 0, 'user', $user, $logged);
            } else {
              ?>
              <div class="frm-post frm-restricted">
                <div class="frm-row"><?php echo _e('This board is available only to premium members', 'forums'); ?></div>
                <div class="frm-row"><?php _e('You have to be member of one of following groups to have access there:', 'forums'); ?> <strong><?php echo frm_board_groups($board); ?></strong></div>
              </div>
              <?php
            }
          }
        ?>
      </div>


      <!-- BOTTOM PAGINATION -->
      <?php echo frm_paginate('', '', $user, 'user', $page_id, $per_page, @$user['i_num_posts'], 'frm-pagination-topic'); ?>

    </div>
  </div>
</div>