<?php
/*
  Plugin Name: Forums Plugin
  Plugin URI: https://osclasspoint.com/osclass-plugins/messaging-and-communication/forums-osclass-plugin-i94
  Description: Create forums for your clients where you can discuss any kind of issues
  Version: 1.5.0
  Author: MB Themes
  Author URI: https://osclasspoint.com
  Author Email: info@osclasspoint.com
  Short Name: forums
  Plugin update URI: forums
  Support URI: https://forums.osclasspoint.com/forums-osclass-plugin/
  Product Key: gcNH3W3tlQR3ckJ7XSCq
*/

define('USER_NAME_TYPE', 'FORUM_NAME');   // OSCLASS_USERNAME or FORUM_NAME


require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'model/ModelFRM.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'functions.php';
require_once osc_plugins_path() . osc_plugin_folder(__FILE__) . 'sitemap.php';

osc_enqueue_style('frm-user-style', osc_base_url() . 'oc-content/plugins/forums/css/user.css?v=' . date('YmdHis'));
osc_enqueue_style('font-awesome47', '//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');
osc_enqueue_style('tipped', osc_base_url() . 'oc-content/plugins/forums/css/tipped.css');
osc_enqueue_style('frm-richtext', osc_base_url() . 'oc-content/plugins/forums/css/richtext.min.css');

osc_register_script('frm-richtext', osc_base_url() . 'oc-content/plugins/forums/js/jquery.richtext.min.js', 'jquery');
osc_register_script('tipped', osc_base_url() . 'oc-content/plugins/forums/js/tipped.js', 'jquery');
osc_register_script('frm-user', osc_base_url() . 'oc-content/plugins/forums/js/user.js?v=' . date('YmdHis'), array('jquery', 'jquery-ui'));


osc_enqueue_script('frm-richtext');
osc_enqueue_script('tipped');
osc_enqueue_script('frm-user');
osc_enqueue_script('jquery-ui');
osc_enqueue_script('jquery-nested');


osc_add_route('frm-board', 'forums/board/(.+)-b([0-9]+)', 'forums/board/{boardSlug}-b{boardId}', osc_plugin_folder(__FILE__).'form/board.php', false, 'frm', 'board-section');
osc_add_route('frm-topic', 'forums/topic/(.+)-t([0-9]+)', 'forums/topic/{topicSlug}-t{topicId}', osc_plugin_folder(__FILE__).'form/topic.php', false, 'frm', 'topic-section');
osc_add_route('frm-user', 'forums/user/(.+)-u([0-9]+)', 'forums/user/{userSlug}-u{userId}', osc_plugin_folder(__FILE__).'form/user.php', false, 'frm', 'user-section');
osc_add_route('frm-manage-topic', 'forums/manage-topic/(.+)-t([0-9]+)', 'forums/manage-topic/{topicAction}-t{topicId}', osc_plugin_folder(__FILE__).'form/topic.php', false, 'frm', 'topic-section');
osc_add_route('frm-manage-post', 'forums/manage-post/(.+)-t([0-9]+)-p([0-9]+)', 'forums/manage-post/{postAction}-t{topicId}-p{postId}', osc_plugin_folder(__FILE__).'form/topic.php', false, 'frm', 'topic-section');
osc_add_route('frm-topic-paginate', 'forums/topic-page/(.+)-t([0-9]+)-p([0-9]+)', 'forums/topic-page/{topicSlug}-t{topicId}-p{pageId}', osc_plugin_folder(__FILE__).'form/topic.php', false, 'frm', 'topic-section');
osc_add_route('frm-board-paginate', 'forums/board-page/(.+)-b([0-9]+)-p([0-9]+)', 'forums/board-page/{boardSlug}-b{boardId}-p{pageId}', osc_plugin_folder(__FILE__).'form/board.php', false, 'frm', 'topic-section');
osc_add_route('frm-user-paginate', 'forums/user-page/(.+)-u([0-9]+)-p([0-9]+)', 'forums/user-page/{userSlug}-u{userId}-p{pageId}', osc_plugin_folder(__FILE__).'form/user.php', false, 'frm', 'user-section');
osc_add_route('frm-post', 'forums/post/', 'forums/post/', osc_plugin_folder(__FILE__).'form/topic.php', false, 'frm', 'topic-section');
osc_add_route('frm-new-topic', 'forums/new-topic/([0-9]+)', 'forums/new-topic/{boardId}', osc_plugin_folder(__FILE__).'form/topic_new.php', false, 'frm', 'topic-new-section');
osc_add_route('frm-profile', 'forums/profile/([0-9]+)', 'forums/profile/{userId}', osc_plugin_folder(__FILE__).'form/profile.php', false, 'frm', 'profile-section');
osc_add_route('frm-search-pre', 'forums/pre-search/', 'forums/pre-search/', osc_plugin_folder(__FILE__).'form/search.php', false, 'frm', 'search-section');
osc_add_route('frm-search', 'forums/search/(.+)', 'forums/search/{searchTerm}', osc_plugin_folder(__FILE__).'form/search.php', false, 'frm', 'search-section');
osc_add_route('frm-search-paginate', 'forums/search-page/(.+)-p([0-9]+)', 'forums/search-page/{searchTerm}-p{pageId}', osc_plugin_folder(__FILE__).'form/search.php', false, 'frm', 'search-section');
osc_add_route('frm-post-page', 'forums/post-page/(.+)-t([0-9]+)-p([0-9]+)/po([0-9]+)', 'forums/post-page/{topicSlug}-t{topicId}-p{pageId}/po{postId}', osc_plugin_folder(__FILE__).'form/topic.php', false, 'frm', 'topic-section');
osc_add_route('frm-activity', 'forums/activity/(.+)', 'forums/activity/{type}', osc_plugin_folder(__FILE__).'form/activity.php', false, 'frm', 'activity-section');
osc_add_route('frm-activity-paginate', 'forums/activity-page/(.+)-p([0-9]+)', 'forums/activity-page/{type}-p{pageId}', osc_plugin_folder(__FILE__).'form/activity.php', false, 'frm', 'activity-section');
//osc_add_route('frm-home', 'forums/home', 'forums/home', osc_plugin_folder(__FILE__).'form/home.php', false, 'frm', 'home-section');
osc_add_route('frm-home', 'forums/', 'forums/', osc_plugin_folder(__FILE__).'form/home.php', false, 'frm', 'home-section');



// MIGRATION OF FILES
function frm_migrate_files() {
  frm_migrate_dir(osc_content_path() . 'plugins/forums/attachment/', osc_content_path() . 'uploads/forums/attachment/');
  frm_migrate_dir(osc_content_path() . 'plugins/forums/img/user/', osc_content_path() . 'uploads/forums/user/');
}

osc_add_hook('init', 'frm_migrate_files');


function frm_migrate_dir($old, $new) {
  if(file_exists($old) && is_dir($old)) {
    osc_mkdir($new);

    $files = array_diff(scandir($old), array('.', '..'));

    if(is_array($files) && count($files) > 0) {
      foreach($files as $file) {
        @rename($old . $file, $new . $file);
      }
    }
    
    @rmdir($old);
  }
}

function frm_check_location() {
  if(osc_get_osclass_location() == 'frm' && frm_param('logged_users_only') == 1 && !osc_is_web_user_logged_in()) {
    osc_add_flash_error_message(__('Forums is available to logged in users only. Please login to access forums', 'forums'));
    header('Location:' . osc_user_login_url());
    exit;
  }
}


osc_add_hook('init', 'frm_check_location');





// INSTALL FUNCTION - DEFINE VARIABLES
function frm_call_after_install() {
  osc_set_preference('topics_per_page', 20, 'plugin-forums', 'INTEGER');
  osc_set_preference('posts_per_page', 20, 'plugin-forums', 'INTEGER');
  osc_set_preference('hook_header_links', 1, 'plugin-forums', 'BOOLEAN');
  osc_set_preference('sanitize', 1, 'plugin-forums', 'INTEGER');
  osc_set_preference('logged_users_only', 0, 'plugin-forums', 'INTEGER');


  ModelFRM::newInstance()->install();
}


function frm_call_after_uninstall() {
  ModelFRM::newInstance()->uninstall();
}



// ADMIN MENU
function frm_menu($title = NULL) {
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/forums/css/admin.css?v=' . date('YmdHis') . '" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/forums/css/bootstrap-switch.css" rel="stylesheet" type="text/css" />';
  echo '<link href="' . osc_base_url() . 'oc-content/plugins/forums/css/tipped.css" rel="stylesheet" type="text/css" />';
  echo '<link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css" />';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/forums/js/admin.js?v=' . date('YmdHis') . '"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/forums/js/tipped.js"></script>';
  echo '<script src="' . osc_base_url() . 'oc-content/plugins/forums/js/bootstrap-switch.js"></script>';



  if( $title == '') { $title = __('Configure', 'forums'); }

  $text  = '<div class="mb-head">';
  $text .= '<div class="mb-head-left">';
  $text .= '<h1>' . $title . '</h1>';
  $text .= '<h2>Forums Plugin</h2>';
  $text .= '</div>';
  $text .= '<div class="mb-head-right">';
  $text .= '<ul class="mb-menu">';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=forums/admin/configure.php"><i class="fa fa-wrench"></i><span>' . __('Configure', 'forums') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=forums/admin/category.php"><i class="fa fa-list-ul"></i><span>' . __('Category', 'forums') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=forums/admin/board.php"><i class="fa fa-th"></i><span>' . __('Board', 'forums') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=forums/admin/layout.php"><i class="fa fa-arrows-alt"></i><span>' . __('Layout', 'forums') . '</span></a></li>';
  $text .= '<li><a href="' . osc_admin_base_url(true) . '?page=plugins&action=renderplugin&file=forums/admin/user.php"><i class="fa fa-user"></i><span>' . __('User', 'forums') . '</span></a></li>';
  $text .= '</ul>';
  $text .= '</div>';
  $text .= '</div>';

  echo $text;
}



// ADMIN FOOTER
function frm_footer() {
  $pluginInfo = osc_plugin_get_info('forums/index.php');
  $text  = '<div class="mb-footer">';
  $text .= '<a target="_blank" class="mb-developer" href="https://osclasspoint.com"><img src="https://osclasspoint.com/favicon.ico" alt="MB Themes" /> osclasspoint.com</a>';
  $text .= '<a target="_blank" href="' . $pluginInfo['support_uri'] . '"><i class="fa fa-bug"></i> ' . __('Report Bug', 'forums') . '</a>';
  $text .= '<a target="_blank" href="https://forums.osclasspoint.com/"><i class="fa fa-handshake-o"></i> ' . __('Support Forums', 'forums') . '</a>';
  $text .= '<a target="_blank" class="mb-last" href="mailto:info@osclasspoint.com"><i class="fa fa-envelope"></i> ' . __('Contact Us', 'forums') . '</a>';
  $text .= '<span class="mb-version">v' . $pluginInfo['version'] . '</span>';
  $text .= '</div>';

  return $text;
}



// ADD MENU LINK TO PLUGIN LIST
function frm_admin_menu() {
echo '<h3><a href="#">Forums Plugin</a></h3>
<ul> 
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/configure.php') . '">&raquo; ' . __('Configure', 'forums') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/category.php') . '">&raquo; ' . __('Category', 'forums') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/board.php') . '">&raquo; ' . __('Board', 'forums') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/layout.php') . '">&raquo; ' . __('Layout', 'forums') . '</a></li>
  <li><a style="color:#2eacce;" href="' . osc_admin_render_plugin_url(osc_plugin_path(dirname(__FILE__)) . '/admin/user.php') . '">&raquo; ' . __('User', 'forums') . '</a></li>
</ul>';
}


// ADD MENU TO PLUGINS MENU LIST
osc_add_hook('admin_menu','frm_admin_menu', 1);



// DISPLAY CONFIGURE LINK IN LIST OF PLUGINS
function frm_conf() {
  osc_admin_render_plugin( osc_plugin_path( dirname(__FILE__) ) . '/admin/configure.php' );
}

osc_add_hook( osc_plugin_path( __FILE__ ) . '_configure', 'frm_conf' );	


// CALL WHEN PLUGIN IS ACTIVATED - INSTALLED
osc_register_plugin(osc_plugin_path(__FILE__), 'frm_call_after_install');

// SHOW UNINSTALL LINK
osc_add_hook(osc_plugin_path(__FILE__) . '_uninstall', 'frm_call_after_uninstall');

?>